﻿using Hotline.Share.Dtos.Order;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Fw.Utility.UnifyResponse;
using RestSharp;

namespace Hotline.Api.Sdk
{
    public partial interface IHotlineClient
    {
        /// <summary>
        /// 省延期结果
        /// </summary>
        public Task<ApiResponse> DelayProvinceResultAsync(DelayProvinceResultDto request, CancellationToken cancellationToken) =>
            ExecuteAsync("api/v1/Order/delay/province/result", Method.Post, request, cancellationToken);

        /// <summary>
        /// 接受其他平台工单数据
        /// </summary>
        public Task<ApiResponse<AddOrderResponse>> ReceiveOrderAsync(AddOrderDto request, CancellationToken cancellationToken) =>
            ExecuteAsync<AddOrderDto, AddOrderResponse>("receive", Method.Post, request, cancellationToken);

        /// <summary>
        /// 接受其他平台工单扩展信息
        /// </summary>
        public Task<ApiResponse<string>> ReceiveExtensionAsync(OrderExtensionDto request, CancellationToken cancellationToken) =>
            ExecuteAsync<OrderExtensionDto, string>("receive/extension", Method.Post, request, cancellationToken);

        /// <summary>
        /// 工单退回结果
        /// </summary>
        public Task<ApiResponse> OrderSendBackResultAsync(OrderSendBackResultDto request, CancellationToken cancellationToken) =>
            ExecuteAsync("api/v1/Order/send_back/result", Method.Post, request, cancellationToken);

        /// <summary>
        /// 督办工单派发
        /// </summary>
        public Task<ApiResponse> ProvinceOrderSuperviseAsync(ProvinceOrderSuperviseDto request, CancellationToken cancellationToken) =>
            ExecuteAsync("api/v1/Order/supervise/province", Method.Post, request, cancellationToken);

        /// <summary>
        /// 催办工单派发
        /// </summary>
        public Task<ApiResponse> ProvinceOrderUrgeAsync(ProvinceOrderUrgeDto request, CancellationToken cancellationToken) =>
            ExecuteAsync("api/v1/Order/urge/province", Method.Post, request, cancellationToken);

        /// <summary>
        /// 省工单甄别结果
        /// </summary>
        public Task<ApiResponse> ScreenProvinceResultAsync(ProvinceScreenResult request, CancellationToken cancellationToken) =>
            ExecuteAsync("api/v1/Order/screen/province/result", Method.Post, request, cancellationToken);
    }
}