﻿using Hotline.Application.Orders;
using Hotline.DataSharing.Province.Notifications;
using MediatR;

namespace Hotline.Application.Handlers.Order;

public class AddOrderTracesAsyncNotifyHandler:INotificationHandler<AddOrderTracesAsyncNotify>
{
    private readonly IOrderApplication _orderApplication;

    public AddOrderTracesAsyncNotifyHandler(IOrderApplication orderApplication)
    {
        _orderApplication = orderApplication;
    }
    
    /// <summary>Handles a notification</summary>
    /// <param name="notification">The notification</param>
    /// <param name="cancellationToken">Cancellation token</param>
    public async Task Handle(AddOrderTracesAsyncNotify notification, CancellationToken cancellationToken)
    {
        await _orderApplication.AddOrderTracesAsync(notification.OrderId, notification.Traces, cancellationToken);
    }
}