﻿using Hotline.Application.Orders;
using Hotline.DataSharing.Province.Notifications;
using MediatR;

namespace Hotline.Application.Handlers.Order;

public class CancelOrderAsyncNotifyHandler : INotificationHandler<CancelOrderAsyncNotify>
{
    private readonly IOrderApplication _orderApplication;

    public CancelOrderAsyncNotifyHandler(IOrderApplication orderApplication)
    {
        _orderApplication = orderApplication;
    }
    
    /// <summary>Handles a notification</summary>
    /// <param name="notification">The notification</param>
    /// <param name="cancellationToken">Cancellation token</param>
    public async Task Handle(CancelOrderAsyncNotify notification, CancellationToken cancellationToken)
    {
        await _orderApplication.CancelOrderAsync(notification.OrderId, notification.Opinion, cancellationToken);
    }
}