﻿using Hotline.CallCenter.BlackLists;
using Hotline.Push.FWMessage;
using Hotline.Settings;
using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.Org;
using Hotline.Share.Dtos.Push.FWMessage;
using Mapster;
using XF.Domain.Entities;

namespace Hotline.Application.Mappers
{
    public partial class MapperConfigs : IRegister
    {
        public void Register(TypeAdapterConfig config)
        {
            config.ForType<AddBlacklistDto, Blacklist>()
                .Ignore(d => d.Expired)
                .AfterMapping((s, t) => t.InitExpired());

            config.ForType<Message, MessageDataDto>()
               .Map(d => d.SendUser, x => x.User.Name)
               .Map(d => d.SendOrganize, x => x.SystemOrganize.Name)
               .Map(d => d.OrderId, x => x.Order.Id)
               .Map(d => d.OrderNo, x => x.Order.No);

            #region org

            config.ForType<UpdateOrgDto, SystemOrganize>()
                .Ignore(d => d.Id)
                .Ignore(d => d.ParentId)
                .Ignore(d => d.ParentName);

            #endregion
        }
    }
}
