﻿using DotNetCore.CAP;
using Hotline.Push.FWMessage;
using Hotline.Share.Dtos.Push;
using XF.Domain.Dependency;

namespace Hotline.Application.Push
{
    public class PushTextMessageHandler : ICapSubscribe, IScopeDependency
    {

        private readonly IPushDomainService _pushDomainService;

        public PushTextMessageHandler(IPushDomainService pushDomainService)
        {
            _pushDomainService = pushDomainService;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="messageDto"></param>
        /// <param name="cancellation"></param>
        /// <returns></returns>
        [CapSubscribe(Hotline.Share.Mq.EventNames.HotlinePushTextMessage)]
        public async Task ReceiveMsg(MessageDto messageDto, CancellationToken cancellation)
        {
            await _pushDomainService.PushAsync(messageDto, cancellation);
        }
    }
}
