﻿using Hotline.Ai.Visit;
using Hotline.Orders;
using StackExchange.Redis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Dependency;
using XF.Domain.Repository;

namespace Hotline.Application.Visit
{
    public class OrderVisitApplication : IOrderVisitApplication, IScopeDependency
    {
        private readonly IRepository<AiOrderVisit> _aiOrderVisitRepository;
        private readonly IAiVisitService _aiVisitService;
        public OrderVisitApplication(IRepository<AiOrderVisit> aiOrderVisitRepository,IAiVisitService aiVisitService)
        {
            _aiOrderVisitRepository = aiOrderVisitRepository;
            _aiVisitService = aiVisitService;
        }


        public async Task AddAiVisit(string aivisitId, CancellationToken cancellationToken)
        {
            var aiOrderVisit =await _aiOrderVisitRepository.Queryable()
                .Includes(x => x.AiOrderVisitDetails, s => s.Order)
                .Includes(x => x.AiOrderVisitDetails, s => s.OrderVisit)
                .FirstAsync(x => x.Id == aivisitId);

            aiOrderVisit = await _aiVisitService.CreateAiOrderVisitTask(aiOrderVisit, cancellationToken);

            await _aiOrderVisitRepository.UpdateNav(aiOrderVisit).Include(d => d.AiOrderVisitDetails).ExecuteCommandAsync();
        }
    }
}
