﻿using Hotline.KnowledgeBase;
using Hotline.Orders;
using Hotline.Repository.SqlSugar.DataPermissions;
using Hotline.Settings;
using SqlSugar;
using XF.Domain.Dependency;

namespace Hotline.Repository.SqlSugar.Knowledge
{
    public class KnowledgeRepository : BaseRepositoryWorkflow<KnowledgeBase.Knowledge>, IKnowledgeRepository, IScopeDependency
    {
        public KnowledgeRepository(ISugarUnitOfWork<HotlineDbContext> uow, IDataPermissionFilterBuilder dataPermissionFilterBuilder) : base(uow, dataPermissionFilterBuilder)
        {

        }
		/// <summary>
		/// 批量删除知识库词库
		/// </summary>
		/// <param name="ids"></param>
		/// <param name="cancellationToken"></param>
		/// <returns></returns>
		public async Task RemoveKnowledgeWrodBatchAsync(List<string> ids, CancellationToken cancellationToken)
		{
			await Db.Deleteable<KnowledgeWord>().In(x => x.Id, ids).ExecuteCommandAsync(cancellationToken);
		}
	}
}
