﻿using Hotline.Share.Enums.FlowEngine;
using Hotline.Share.Enums.Settings;

namespace Hotline.Share.Dtos.FlowEngine;

/// <summary>
/// 工作流流转基础信息
/// </summary>
public class BasicWorkflowDto : EndWorkflowDto
{
    /// <summary>
    /// 下一节点code(defineStep.code)
    /// </summary>
    public string NextStepCode { get; set; } = string.Empty;
    public string NextStepName { get; set; } = string.Empty;

    /// <summary>
    /// 是否回到会签发起节点汇总
    /// </summary>
    public bool BackToCountersignEnd { get; set; }

    public EFlowDirection? FlowDirection { get; set; }

    /// <summary>
    /// 根据办理者类型不同，此字段为不同内容
    /// <example>
    /// 部门等级/分类为：depCodes, 角色为：userIds
    /// </example>
    /// </summary>
    public List<Kv> NextHandlers { get; set; } = new();

    /// <summary>
    /// 是否短信通知
    /// </summary>
    public bool IsSms { get; set; }

    /// <summary>
    /// 下一节点主办
    /// </summary>
    public string? NextMainHandler { get; set; }

    /// <summary>
    /// 发起会签
    /// </summary>
    public bool IsStartCountersign { get; set; }

    /// <summary>
    /// 外部业务参数
    /// </summary>
    public External External { get; set; }

}

public class External
{
    public int? TimeLimit { get; set; }
    public ETimeType? TimeLimitUnit { get; set; }
}