﻿using Hotline.Settings;
using Hotline.Share.Requests;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.Knowledge
{
	public class KnowledgeBiDataListVo
	{
		public string OrgName { get; set; }

		public string OrgId { get; set; }
		/// <summary>
		/// 部门类型
		/// </summary>
		public EOrgType OrgType { get; set; }

		public int AddNum { get; set; }

		public int DeleteNum { get; set; }

		public int SendBackNum { get; set; }

		public int PassNum { get; set; }

		public string OrgTypeText => OrgType.GetDescription();
	}


	public record KnowledgeBiDataListDto : PagedKeywordRequest
	{
		/// <summary>
		/// 开始时间
		/// </summary>
		public DateTime? CreationTimeStart { get; set; }

		/// <summary>
		/// 结束时间
		/// </summary>
		public DateTime? CreationTimeEnd { get; set; }

		/// <summary>
		/// 排序字段 0 新增数量 1 删除数量 2 退回数量 3 通过数量
		/// </summary>
		public string SortField { get; set; }

		/// <summary>
		/// 排序规则  0 升序  1 降序
		/// </summary>
		public int SortRule { get; set; }
	}
}
