﻿using Hotline.Share.Enums.Order;

namespace Hotline.Share.Dtos.Order;

public class OrderComplainDto : OrderExtensionDto
{
    #region 投诉详情

    /// <summary>
    /// 投诉问题类别
    /// </summary>
    public string ComplainClassifyCode { get; set; }

    public string ComplainClassify { get; set; }

    /// <summary>
    /// 争议发生时间
    /// </summary>
    public DateTime OccurrenceTime { get; set; }

    /// <summary>
    /// 投诉目标，销售方式为“网购”时展示该字段且必填
    /// </summary>
    public string? ComplainTargetCode { get; set; }

    public string? ComplainTarget { get; set; }

    /// <summary>
    /// 经营地址，销售方式为“现场”时必填
    /// </summary>
    public Position BusinessPosition { get; set; }

    /// <summary>
    /// 诉求类型，多选
    /// </summary>
    public List<Kv> ComplainTypes { get; set; } = new();

    #endregion
}