﻿using Hotline.Share.Enums.Settings;
using Hotline.Share.Requests;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline.Share.Dtos.Settings
{
    public class AddCommonDto
    {
        /// <summary>
        /// 内容
        /// </summary>
        public string Content { get; set; }

        public bool IsOpen { get; set; }

        public ECommonType CommonType { get; set; }
    }

    public class CommonModifyDto:AddCommonDto
    {
        public string Id { get; set; }
    }

    public class DelCommonDto
    {
        /// <summary>
        /// 主键ID集合
        /// </summary>
        public string[] Ids { get; set; }
    }


    public record QueryCommonDto: PagedRequest
    {
        public ECommonType? CommonType { get; set; }
        
        public string? UserName { get; set; }

        public bool? IsOpen{ get; set; }
    }




    public class AddAreaDto
    {
        public string AreaName { get; set; }
            
        public string ParentId { get; set; }

        public string AreaNameAbbreviation { get; set; }

    }

    public class ModifyAreaDto : AddAreaDto
    {
        public string Id { get; set; }
    }


}
