﻿namespace Hotline.Share.Enums.FlowEngine;

/// <summary>
/// 节点处于会签流程中的位置
/// </summary>
public enum ECountersignPosition
{
    /// <summary>
    /// 无会签（未处于会签流程中，外层也无会签嵌套）
    /// </summary>
    None = 0,

    /// <summary>
    /// 办理会签（上级节点直接开启会签）
    /// </summary>
    Inner = 1,

    /// <summary>
    /// 本身不直接处于会签流程中，但外层有会签流程嵌套（非上级节点开启会签，当前节点会签并未结束）
    /// </summary>
    Outer = 2
}