﻿namespace Hotline.Share.Requests;

public record PagedKeywordRequest : PagedRequest
{
    public string? Keyword { get; set; }
}

public record ReportPagedRequest : PagedKeywordRequest 
{

	/// <summary>
	/// 开始时间
	/// </summary>
	public DateTime? StartTime { get; set; }

	/// <summary>
	/// 结束时间
	/// </summary>
	public DateTime? EndTime { get; set; }

	/// <summary>
	/// 排序字段 
	/// </summary>
	public string SortField { get; set; }

	/// <summary>
	/// 排序规则  0 升序  1 降序
	/// </summary>
	public int SortRule { get; set; }

}

public record HotspotReportPagedRequest : ReportPagedRequest { 

	public string Id { get; set; }
}


public record QuerySeatRestRequest:ReportPagedRequest
{
	public string? UserName { get; set; }

	public string? StaffNo { get; set; }

}

public record QuerySeatSwitchRequest:ReportPagedRequest
{
	public string? UserName { get; set; }

	public string? CDPN { get; set; }

}

public record QueryVisitNoSatiisfiedRequest:ReportPagedRequest
{
	public string? OrgName { get; set; }

}

public record BiQueryVisitNoSatisfiedDetailDto: ReportPagedRequest
{
	/// <summary>
	/// 部门Code
	/// </summary>
	public string OrgCode { get; set; }
	/// <summary>
	/// 不满意原因Key
	/// </summary>
	public string DissatisfiedKey { get; set; }
}

public record QueryOrderDelayDataListRequest:ReportPagedRequest 
{ 
	public string? OrgName { get; set; }
}