﻿//using Hotline.Share.Dtos;
//using Hotline.Share.Enums.FlowEngine;
//using SqlSugar;

//namespace Hotline.FlowEngine.Workflows;

//public class WorkflowStep1 : StepBasicEntity
//{
//    [SugarColumn(ColumnDataType = "json", IsJson = true)]
//    public List<StepSimple> NextSteps { get; set; }

//    /// <summary>
//    /// 前一级节点Id(stepBox此字段为上级stepBoxId,step为上级stepId),汇总节点无此字段（因可能有多个上级来源）
//    /// </summary>
//    [SugarColumn(IsNullable = true)]
//    public string? PreviousId { get; set; }

//    /// <summary>
//    /// 主办
//    /// </summary>
//    public bool IsMain { get; set; }

//    /// <summary>
//    /// 节点办理状态
//    /// </summary>
//    public EWorkflowStepStatus Status { get; set; } = EWorkflowStepStatus.WaitForAccept;

//    /// <summary>
//    /// stepBox此字段无效，记录stepBox与其下subSteps关系
//    /// </summary>
//    public string? ParentId { get; set; }

//    [SugarColumn(IsIgnore = true)]
//    public List<WorkflowStep> Steps { get; set; } = new();

//    #region 会签

//    /// <summary>
//    /// 发起会签生成会签Id（不发起会签节点无此字段）
//    /// </summary>
//    [SugarColumn(IsNullable = true)]
//    public string? StartCountersignId { get; set; }

//    /// <summary>
//    /// 会签id
//    /// </summary>
//    [SugarColumn(IsNullable = true)]
//    public string? CountersignId { get; set; }

//    /// <summary>
//    /// 当前节点发起的会签是否已结束，冗余（未发起会签的节点此字段为null）
//    /// <remarks>
//    /// 发起的会签结束以后更新，如果有子会签，则所有子会签都结束以后才会更新此字段
//    /// </remarks>¡
//    /// </summary>
//    public bool? IsStartedCountersignComplete { get; set; }

//    /// <summary>
//    /// 节点会签状态
//    /// </summary>
//    public ECountersignPosition CountersignPosition { get; set; }

//    /// <summary>
//    /// 发起会签节点code（冗余）
//    /// </summary>
//    [SugarColumn(IsNullable = true)]
//    public string? CountersignStartStepCode { get; set; }

//    /// <summary>
//    /// 会签汇总节点code（冗余）
//    /// </summary>
//    [SugarColumn(IsNullable = true)]
//    public string? CountersignEndStepCode { get; set; }

//    /// <summary>
//    /// 是否处于会签流程中
//    /// </summary>
//    [SugarColumn(IsIgnore = true)]
//    public bool IsInCountersign => !string.IsNullOrEmpty(CountersignId);

//    /// <summary>
//    /// 是否发起过会签
//    /// </summary>
//    [SugarColumn(IsIgnore = true)]
//    public bool HasStartedCountersign => !string.IsNullOrEmpty(StartCountersignId);

//    #endregion

//    #region Method

//    /// <summary>
//    /// 接办
//    /// </summary>
//    /// <param name="userId"></param>
//    /// <param name="userName"></param>
//    public void Accept(string userId, string? userName, string orgCode, string? orgName)
//    {
//        AcceptorId = userId;
//        AcceptorName = userName;
//        AcceptTime = DateTime.Now;
//        AcceptorOrgId = orgCode;
//        AcceptorOrgName = orgName;
//        Status = EWorkflowStepStatus.WaitForHandle;
//    }

//    /// <summary>
//    /// 节点办理完成
//    /// </summary>
//    /// <param name="userId"></param>
//    /// <param name="userName"></param>
//    /// <param name="orgCode"></param>
//    /// <param name="orgName"></param>
//    public void Complete(string userId, string? userName, string orgCode, string? orgName, string? areaCode, string? areaName, string nextStepCode)
//    {
//        HandlerId = userId;
//        HandlerName = userName;
//        HandlerOrgId = orgCode;
//        HandlerOrgName = orgName;
//        HandlerOrgAreaCode = areaCode;
//        HandlerOrgAreaName = areaName;
//        HandleTime = DateTime.Now;
//        Status = EWorkflowStepStatus.Handled;

//        if (StepType is not EStepType.End or EStepType.Start)
//            NextSteps.First(d => d.Code == nextStepCode).Selected = true;
//    }

//    /// <summary>
//    /// 检查stepBox状态，如果子节点全都办理，则stepBox办理完成
//    /// </summary>
//    public void CheckStepBoxStatusAndUpdate()
//    {
//        if (Status is not EWorkflowStepStatus.Handled && Steps.All(d => d.Status is EWorkflowStepStatus.Handled))
//        {
//            Status = EWorkflowStepStatus.Handled;
//            HandleTime = Steps.Max(d => d.HandleTime);
//        }
//    }

//    /// <summary>
//    /// 会签结束
//    /// </summary>
//    public void CountersignComplete() => IsStartedCountersignComplete = true;

//    /// <summary>
//    /// 开启会签
//    /// </summary>
//    public void StartCountersign(string startCountersignId)
//    {
//        StartCountersignId = startCountersignId;
//        IsStartedCountersignComplete = false;
//    }

//    /// <summary>
//    /// step设置为可接办状态
//    /// </summary>
//    public void SetAssigned() => Status = EWorkflowStepStatus.WaitForAccept;

//    /// <summary>
//    /// 依据当前节点获取下一节点会签状态
//    /// </summary>
//    /// <returns></returns>
//    public ECountersignPosition GetNextStepCountersignStatus()
//    {
//        if (HasStartedCountersign)
//        {
//            return ECountersignPosition.Inner;
//        }
//        return IsInCountersign ? ECountersignPosition.Outer : ECountersignPosition.None;
//    }

//    /// <summary>
//    /// 重置节点,只清除办理痕迹（退回场景，将上一级节点重置等待重新办理）
//    /// </summary>
//    public void Reset()
//    {
//        SetAssigned();
//        NextHandlers = new();
//        NextMainHandler = null;
//        NextStepCode = string.Empty;
//        IsSms = default;
//        Opinion = string.Empty;
//        Additions = new();

//        HandlerId = null;
//        HandlerName = null;
//        HandlerOrgId = null;
//        HandlerOrgName = null;
//        HandleTime = null;

//        AcceptorId = null;
//        AcceptorName = null;
//        AcceptorOrgId = null;
//        AcceptorOrgName = null;
//        AcceptTime = null;
//    }

//    #endregion

//}