﻿using Hotline.Share.Enums.Order;
using Hotline.Users;
using SqlSugar;
using System.ComponentModel;
using XF.Domain.Repository;

namespace Hotline.Orders;

/// <summary>
/// 已发布工单
/// </summary>
[Description("工单发布")]
public class OrderPublish : FullStateEntity
{
    public string OrderId { get; set; }

    /// <summary>
    /// 工单编码（冗余）
    /// </summary>
    public string No { get; set; }

    /// <summary>
    /// 发布范围
    /// </summary>
    public bool PublishState { get; set; }

    /// <summary>
    /// 整理标题
    /// </summary>
    public string ArrangeTitle { get; set; }

    /// <summary>
    /// 整理内容
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(2000)")]
    public string ArrangeContent { get; set; }

    /// <summary>
    /// 整理结果
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(2000)")]
    public string ArrangeOpinion { get; set; }

    /// <summary>
    /// 已发布工单
    /// </summary>
    [Navigate(NavigateType.OneToOne, nameof(OrderId))]
    public Order Order { get; set; }

    #region 省工单使用字段

    /// <summary>
    /// 省是否公开
    /// </summary>
    public bool? ProPublishState { get; set; }

    /// <summary>
    /// 反馈电话
    /// </summary>
    [SugarColumn(IsNullable = true)]
    public string FeedBackPhone { get; set; }

    /// <summary>
    /// 不公开原因
    /// </summary>
    [SugarColumn(IsNullable = true)]
    public string NoPubReason { get; set; }
    #endregion
}