﻿namespace XF.Domain.Entities;

public interface IWorkflow
{
    string? WorkflowId { get; set; }

    /// <summary>
    /// 过期时间配置id
    /// </summary>
    string? ExpiredTimeConfigId { get; set; }

    /// <summary>
    /// 流经部门
    /// </summary>
    List<string> FlowedOrgIds { get; set; }

    /// <summary>
    /// 流经办理人
    /// </summary>
    List<string> FlowedUserIds { get; set; }

    ///// <summary>
    ///// 指派角色名称
    ///// </summary>
    //List<string> AssignRoles { get; set; }

    void Assign(EFlowAssignType type, string handler);

    void Assign(EFlowAssignType type, IEnumerable<string> handlers);
}

public enum EFlowAssignType
{
    /// <summary>
    /// 指派到部门
    /// </summary>
    Org = 0,

    /// <summary>
    /// 指派到用户
    /// </summary>
    User = 1,

    ///// <summary>
    ///// 指派到角色
    ///// </summary>
    //Role = 2,
}