using Hotline.Api.Sdk;
using Hotline.Share.Dtos.Order;
using Microsoft.AspNetCore.Mvc;

namespace WebApplication1.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
        "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
    };

        private readonly IHotlineClient _hotlineClient;
        private readonly ILogger<WeatherForecastController> _logger;

        public WeatherForecastController(
            IHotlineClient hotlineClient,
            ILogger<WeatherForecastController> logger)
        {
            _hotlineClient = hotlineClient;
            _logger = logger;
        }

        [HttpGet(Name = "GetWeatherForecast")]
        public IEnumerable<WeatherForecast> Get()
        {
            return Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateOnly.FromDateTime(DateTime.Now.AddDays(index)),
                TemperatureC = Random.Shared.Next(-20, 55),
                Summary = Summaries[Random.Shared.Next(Summaries.Length)]
            })
            .ToArray();
        }

        [HttpGet("test")]
        public async Task Test()
        {
            await _hotlineClient.DelayProvinceResultAsync(
                new DelayProvinceResultDto { IsPass = true, No = "123", Opinion = "aaa" }, HttpContext.RequestAborted);
        }
    }
}